using FluentValidation;
using CMSMicroservice.Protobuf.Protos.FactorDetails;
namespace CMSMicroservice.Protobuf.Validator.FactorDetails;

public class GetFactorDetailsRequestValidator : AbstractValidator<GetFactorDetailsRequest>
{
    public GetFactorDetailsRequestValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetFactorDetailsRequest>.CreateWithOptions((GetFactorDetailsRequest)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
